/**
  * 3 SimpleScopes XBee
  */

 import processing.funnel.*;

 final int[] moduleIDs = {1,2};
 final int kChannles = 3;  // the number of channels to display
 final int kPoints = 200;  // the number of points to display
// final int id = 3; // end device ID

 XBee xbee;
 float values[][][];
 int index = 0;

 void setup()
 {
   size(400*moduleIDs.length, 400);
   frameRate(30);

   xbee = new XBee(this, moduleIDs);
   
   values = new float[moduleIDs.length][kChannles][kPoints];

   for(int id = 0; id < moduleIDs.length; id++){
     for (int channel = 0; channel < kChannles; channel++) {
       for (int i = 0; i < kPoints; i++) {
         values[id][channel][i] = 0;
       }
     }
   }
 }

 final int kLeft = 35;
 final int kTop = 25;
 final int kHeight = 100;

 void draw()
 { 
   background(0);

   smooth();

   for(int id = 0; id < moduleIDs.length; id++){
   for (int channel = 0; channel < kChannles; channel++) {
     int offsetX = id * 400;
     int offset = channel * 130;

     textSize(12);
     text("id:"+moduleIDs[id]+" analogInput(" + channel + ")", kLeft - 24 + offsetX, kTop - 8 + offset);
     text("1.0", kLeft - 24 + offsetX, kTop + 8 + offset);
     text("0.0", kLeft - 24 + offsetX, kTop + kHeight + offset);
     text("val: " + xbee.iomodule(moduleIDs[id]).pin(channel).value, kLeft + kPoints + 8 + offsetX, kTop + 8 + offset);
     text("max: " + xbee.iomodule(moduleIDs[id]).pin(channel).maximum, kLeft + kPoints + 8 + offsetX, kTop + 20 + offset);
     text("min: " + xbee.iomodule(moduleIDs[id]).pin(channel).minimum, kLeft + kPoints + 8 + offsetX, kTop + 32 + offset);
     text("avg: " + xbee.iomodule(moduleIDs[id]).pin(channel).average, kLeft + kPoints + 8 + offsetX, kTop + 44 + offset);

     values[id][channel][index] = xbee.iomodule(moduleIDs[id]).pin(channel).value;

     // draw outlines
     stroke(200);
     noFill();
     beginShape();
     vertex(kLeft - 1 + offsetX, kTop - 1 + offset);
     vertex(kLeft + kPoints + offsetX, kTop - 1 + offset);
     vertex(kLeft + kPoints + offsetX, kTop + kHeight + offset);
     vertex(kLeft - 1 + offsetX, kTop + kHeight + offset);
     endShape(CLOSE);

     // draw the signal
     stroke(255);
     beginShape();
     for (int i = 1; i < kPoints; i++) {
       vertex(kLeft + i + offsetX, kTop + kHeight - values[id][channel][(index + i) % kPoints] * (float)kHeight + offset);
     }
     endShape();
   }
   }

   index = (index + 1) % kPoints;
 }
